datablock particleData( subtractorTrailParticle )
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 6;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1 0.5 0.5 1";
	colors[1]     = "1 0.5 0.5 1";
   colors[2]     = "1 0.5 0.5 1";
   colors[3]     = "1 0.5 0.5 1";

	sizes[0]      = 1;
	sizes[1]      = 1;
   sizes[2]      = 1;
 	sizes[3]      = 1;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock particleEmitterData( subtractorTrailEmitter )
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "subtractorTrailParticle";

   uiName = "Subtractor Trail";
};

datablock explosionData( subtractorExplosion )
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 1;
};

datablock projectileData( subtractorProjectile )
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamageType = $DamageType::Fall;
   radiusDamageType = $DamageType::Fall;
   explosion           = subtractorExplosion;
   particleEmitter     = subtractorTrailEmitter;

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 10;
   lightColor  = "1 0.5 0.0";

   uiName = "Subtractor";
};

datablock itemData( subtractorItem )
{
	shapeFile = "base/data/shapes/printGun.dts";
	uiName = "Subtractor";
	doColorShift = true;
	colorShiftColor = "1 0.5 0.5 1";
	image = subtractorImage;
	canDrop = true;
};

datablock shapeBaseImageData( subtractorImage : printGunImage )
{
   item = subtractorItem;
   projectile = subtractorProjectile;

	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;
   minShotTime = 1000;
   doColorShift = true;
   colorShiftColor = "0.5 1 0.5 1";
   stateAllowImageChange[ 0 ] = false;
   stateTimeoutValue[ 0 ] = 1;
};

function subtractorImage::onFire( %this, %obj, %slot )
{
	%start = %obj.getMuzzlePoint( 0 );
	%vectr = vectorScale( %obj.getMuzzleVector( 0 ), %this.projectile.muzzleVelocity );
	
	%obj = new Projectile()
	{
		position = %start;
		datablock = %this.projectile;
		initialPosition = %start;
		initialVelocity = %vectr;
		sourceObject = %obj;
		sourceClient = %obj.client;
	};
	
	missionCleanup.add( %obj );
}

function subtractorProjectile::onCollision( %this, %obj, %col )
{
   %class = %col.getClassName();

   if ( miniGameCanDamage( %obj, %col ) && ( %class $= "Player" || %class $= "AIPlayer" || %class $= "WheeledVehicle" || %class $= "FlyingVehicle" || %class $= "HoverVehicle" ) )
	{
		%col.setVelocity( vectorScale( %obj.initialVelocity, -1 ) );
	}
}